(********************************************************************************)
(*  ocamlcore-api: Access to OCamlCore.org services                             *)
(*                                                                              *)
(*  Copyright (C) 2011, OCamlCore SARL                                          *)
(*                                                                              *)
(*  This library is free software; you can redistribute it and/or modify it     *)
(*  under the terms of the GNU Lesser General Public License as published by    *)
(*  the Free Software Foundation; either version 2.1 of the License, or (at     *)
(*  your option) any later version, with the OCaml static compilation           *)
(*  exception.                                                                  *)
(*                                                                              *)
(*  This library is distributed in the hope that it will be useful, but         *)
(*  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY  *)
(*  or FITNESS FOR A PARTICULAR PURPOSE. See the file COPYING for more          *)
(*  details.                                                                    *)
(*                                                                              *)
(*  You should have received a copy of the GNU Lesser General Public License    *)
(*  along with this library; if not, write to the Free Software Foundation,     *)
(*  Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA               *)
(********************************************************************************)

(** Manage fake data for tests
    @author Sylvain Le Gall
  *)

open Lwt 

type 'a t = 
    (int * 'a) list ref

let create () = 
  ref []

let add t (stub_id: int) data = 
  t := (stub_id, data) :: !t

let get t stub_id fltr = 
  let res = 
    List.filter 
      (fun (stub_id', data) ->
         stub_id' = stub_id && fltr data)
      !t
  in
    Lwt.return (List.rev_map snd res)

let get_one t stub_id fltr = 
  try 
    let res = 
      List.find
        (fun (stub_id', data) ->
           stub_id' = stub_id && fltr data)
        !t
    in
      return (snd res)
  with e ->
    fail e

let filter t stub_id fltr = 
  t := List.filter 
         (fun (stub_id', data) ->
            stub_id' = stub_id && fltr data)
         !t
    
