(********************************************************************************)
(*  ocamlcore-api: Access to OCamlCore.org services                             *)
(*                                                                              *)
(*  Copyright (C) 2011, OCamlCore SARL                                          *)
(*                                                                              *)
(*  This library is free software; you can redistribute it and/or modify it     *)
(*  under the terms of the GNU Lesser General Public License as published by    *)
(*  the Free Software Foundation; either version 2.1 of the License, or (at     *)
(*  your option) any later version, with the OCaml static compilation           *)
(*  exception.                                                                  *)
(*                                                                              *)
(*  This library is distributed in the hope that it will be useful, but         *)
(*  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY  *)
(*  or FITNESS FOR A PARTICULAR PURPOSE. See the file COPYING for more          *)
(*  details.                                                                    *)
(*                                                                              *)
(*  You should have received a copy of the GNU Lesser General Public License    *)
(*  along with this library; if not, write to the Free Software Foundation,     *)
(*  Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA               *)
(********************************************************************************)

(** Web interfaces for OCamlCore API
    @author Sylvain Le Gall
  *)

type t = Context.t

open Eliom_services

type ('a, 'b) service = 
    ('a, unit, get_service_kind, [`WithoutSuffix], 'b, unit, registrable) 
      Eliom_services.service

let create = 
  Context.create 

let create_from_config = 
  Context.create_from_config


let to_oca_context =
  Context.to_oca_context

module Session =
struct
  let get = 
    Session.get 

  let action_box =
    Session.action_box

  let login_get = 
    Session.login_get

  let logout_get = 
    Session.logout_get 

  let with_login =
    Session.with_login 
end

module Account = 
struct
  let get =
    Account.get 

  let user_settings_box =
    Account.user_settings_box 

  let my_account =
    Account.my_account

  let new_account =
    Account.new_account

  let manage_account =
    Account.manage_account

  let lost_passwd =
    Account.lost_passwd 
end

module Template =
struct
  let make_page = 
    Template.make_page
end

module Redirect =
struct 
  let rewrite ~ctxt sp uri = 
    XHTML.M.uri_of_string
      (ctxt.Context.web_redirect sp 
         (XHTML.M.string_of_uri uri))
end

